﻿from Tkinter import *
import tkMessageBox
import shutil
import os.path 

import pyodbc

import sys
reload(sys)
sys.setdefaultencoding('utf-8')

#Function copyfile หรือสร้างฐานข้อมูล
def cpfile():
	if E1.get() == "":
		tkMessageBox.showinfo("พบข้อผิดพลาด", "ท่านยังไม่ได้ตั้งชื่อฐานข้อมูล" )
	elif os.path.isfile(E1.get()+'.mdb'):
		tkMessageBox.showinfo("สถานะ", "มีฐานข้อมูล :" + E1.get()+'.mdb \n อยู่แล้ว' )
		B1['state'] = DISABLED
		E1['state'] = DISABLED
		
		ETN2['state'] = NORMAL
		BTN1['state'] = NORMAL
		
		ET2['state'] = NORMAL
		#BT2['state'] = NORMAL
		
		ETN2.focus_set()
		
	else:
		shutil.copy2('TmpDB.mdb', E1.get()+'.mdb') 
		tkMessageBox.showinfo("สถานะ", "สร้างฐานข้อมูล :" + E1.get()+'.mdb สำเร็จ' )
		B1['state'] = DISABLED
		E1['state'] = DISABLED
		
		ETN2['state'] = NORMAL
		BTN1['state'] = NORMAL
		
		ET2['state'] = NORMAL
		#BT2['state'] = NORMAL
		
		ETN2.focus_set()

#Function สร้างตาราง กับ หนึ่ง Field	
def mkTable():
	if ETN2.get() == "":
		tkMessageBox.showinfo("พบข้อผิดพลาด", "ท่านยังไม่ได้ตั้งชื่อตาราง" )
	elif ET2.get() == "":
		tkMessageBox.showinfo("พบข้อผิดพลาด", "ท่านยังไม่ได้ตั้งชื่อ Field" )
	else:
		print "สร้าง table + Field"
		strConn = 'DRIVER={Microsoft Access Driver (*.mdb)};DBQ=' + E1.get()+'.mdb'  
		
		print "strConn = " + strConn
		db = pyodbc.connect(strConn,autocommit=True)
		cursor = db.cursor()
		if var.get() == 'Text':
			strSQL = "CREATE TABLE " + ETN2.get() + "   (" + ET2.get() + " VARCHAR(" + ES1.get() + "))"
			print "strSQL = " + strSQL
		else:
			strSQL = "CREATE TABLE " + ETN2.get() + "(" + ET2.get() +  " " + var.get() +")"
			print "strSQL = " + strSQL
		cursor.execute(strSQL)
		db.close
		
		ETN2['state'] = DISABLED
		BTN1['state'] = DISABLED
		
		BT2['state'] = NORMAL
		tkMessageBox.showinfo("สถานะ", "สร้างตาราง :" + ETN2.get() + " และสร้าง Field: " + ET2.get() + "แล้ว" )
		ET2.delete(0, END)
		
def mkField():
	if ET2.get() == "":
		tkMessageBox.showinfo("พบข้อผิดพลาด", "ท่านยังไม่ได้ตั้งชื่อ Field" )
	else:
		print "สร้าง Field"
		strConn = 'DRIVER={Microsoft Access Driver (*.mdb)};DBQ=' + E1.get()+'.mdb'  
		
		print "strConn = " + strConn
		db = pyodbc.connect(strConn,autocommit=True)
		cursor = db.cursor()
		if var.get() == 'Text':
			strSQL = "ALTER TABLE " + ETN2.get() + " ADD COLUMN " + ET2.get() + " VARCHAR(" + ES1.get() + ")"
			print "strSQL = " + strSQL
		else:
			strSQL = "ALTER TABLE " + ETN2.get() + " ADD COLUMN " + ET2.get() +  " " + var.get() 
			print "strSQL = " + strSQL
		cursor.execute(strSQL)
		db.close
		
		tkMessageBox.showinfo("สถานะ", "เพิ่ม Field: " + ET2.get() + "แล้ว" )
		ET2.delete(0, END)

root = Tk()

#สร้างฐานข้อมูล

L1 = Label(root, text="กรอกชื่อฐานข้อมูล" )
L1.grid(row=0, column=0, sticky = W)
E1 = Entry(root, bd =5)
E1.focus_set()
E1.grid(row = 0, column =1 ,columnspan=2, sticky = E)
B1= Button(root, text="สร้าง", command = cpfile)
B1.grid(row = 0, column= 3)

#สร้างตาราง

LTN1 = Label(root, text="สร้าง ตาราง")
LTN1.grid(row = 1, column = 0,sticky = W)
ETN2 = Entry(root, state = DISABLED, bd = 5)
ETN2.grid(row = 1, column = 1,columnspan=2, sticky = E)
BTN1 = Button(root, text="สร้าง", state = DISABLED, command = mkTable)
BTN1.grid(row = 1, column = 3)

#ชนิดของ Field : Currency Memo Number Text Single Double BIT
#สร้าง Field

LT1 = Label(root, text="สร้าง Field" )
LT1.grid(row = 2, column = 0,sticky = W)
LT2 = Label(root, text="ชื่อ Field" )
LT2.grid(row = 2, column = 1,sticky = W)
ET2 = Entry(root, state = DISABLED, bd =5)
ET2.grid(row = 2, column = 2)
BT2= Button(root, text="สร้าง", state = DISABLED, command = mkField)
BT2.grid(row = 2, column = 3)


var = StringVar()
R1 = Radiobutton(root, text="Text ", variable=var, value="Text" )
R1.select()
R1.grid( row = 3, column = 0 ,sticky = W)
R2 = Radiobutton(root, text="Long Integer", variable=var, value="INTEGER")
R2.deselect()
R2.grid( row = 4, column = 0 ,sticky = W)
R3 = Radiobutton(root, text="Double", variable=var, value="Double")
R3.deselect()
R3.grid( row = 5, column = 0,sticky = W)

#ขนาด ข้อมูลแบบ Text

LS1 = Label(root, text="Size" )
LS1.grid(row =  3, column = 1,sticky = W)
ES1 = Entry(root, bd =5)
ES1.insert(0,"50")
ES1.grid(row = 3, column = 2)


root.mainloop()